import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;


import smile.Network;


public class Sociaty 
{
//	public static final int SocEco_poor = 0;
//	public static final int SocEco_medium = 1;
//	public static final int SocEco_rich = 2;

	public static final int focalNums = 20;
	public static final int randomfocalLinks = 20;
	public static final double SocEco_rich_thr = 1.7;
	public static final double SocEco_medium_thr = 0.3;
	
	public static final double neighbourRangeR = 10;
	
	public static final int loc_low = 0;
	public static final int loc_medium = 1;
	public static final int loc_high = 2;
	
	public static final int ob_low = 0;
	public static final int ob_medium = 1;
	public static final int ob_high = 2;		

	private String[] hAdv_ReactValues = new String[3];
	private String[] ad_ReactValues = new String[3];
	private String[] reactValues = new String[3];
	private String[] actionValues = new String[3];
	
	private List<SourceMeme> sourceMemes;

	private int[][] group;
	private double[] averageHAdvEnergy;
	private double[] totalHAdvEnergy;
	private double[] averageAdEnergy;
	private double[] totalAdEnergy;
	
	double reactThre; 
	double actionThre; 
	
//	private static double[][] actionProbs;
	private double[][] react_group;
	private double[] action;
	
//	private static String path = "D:\\workspace\\BNIntervention\\model\\";
//	public static String model_path = "P:\\project\\workspace\\BNIntervention\\model\\";
//	public static String result_path = "P:\\project\\workspace\\BNIntervention\\fullResults\\29-09-2010\\";
	public static String model_path = "D:\\workspace\\BNIntervention\\model\\";
	public static String result_path = "D:\\workspace\\BNIntervention\\highDiff-lowEnergy-HAdv\\";
//	public static String result_path = "D:\\workspace\\BNIntervention\\";
	
	private static String netFile = "intervention.xdsl";	
	public static Network bayesNet;
	
	public static int population = 90;
	public static int iteration = 50;
	
	public static List<Ego> egos = null;
	
	Sociaty()
	{
		//define memes
		sourceMemes = new ArrayList<SourceMeme>();
//		sourceMemes.add(new SourceMeme(1, 0.0d, 0, 2, 0.02d, 0.9, SourceMeme.HADV, SourceMeme.randonNetMode));
//		sourceMemes.add(new SourceMeme(2, 0.0d, 0, 10, 0.05d, 0.95, SourceMeme.AD, SourceMeme.randonNetMode));
		
		//define bayesian nets
		bayesNet = new Network();
		bayesNet.readFile(model_path + netFile); 
		
		
		//define egos
		egos = new ArrayList<Ego>();
		for(int i = 0; i < population; i++)
		{
			egos.add(new Ego(i));
		}		
		
		group = new int[3][3];
		group[loc_low][ob_low] = 10;
		group[loc_low][ob_medium] = 10;
		group[loc_low][ob_high] = 10;
		group[loc_medium][ob_low] = 10;
		group[loc_medium][ob_medium] = 10;
		group[loc_medium][ob_high] = 10;		
		group[loc_high][ob_low] = 10;
		group[loc_high][ob_medium] = 10;
		group[loc_high][ob_high] = 10;		

//		group[SocEco_medium][loc_low][ob_low] = 10;
//		group[SocEco_medium][loc_low][ob_medium] = 10;
//		group[SocEco_medium][loc_low][ob_high] = 10;
//		group[SocEco_medium][loc_medium][ob_low] = 10;
//		group[SocEco_medium][loc_medium][ob_medium] = 10;
//		group[SocEco_medium][loc_medium][ob_high] = 10;		
//		group[SocEco_medium][loc_high][ob_low] = 10;
//		group[SocEco_medium][loc_high][ob_medium] = 10;
//		group[SocEco_medium][loc_high][ob_high] = 10;
//		
//		group[SocEco_rich][loc_low][ob_low] = 10;
//		group[SocEco_rich][loc_low][ob_medium] = 10;
//		group[SocEco_rich][loc_low][ob_high] = 10;
//		group[SocEco_rich][loc_medium][ob_low] = 10;
//		group[SocEco_rich][loc_medium][ob_medium] = 10;
//		group[SocEco_rich][loc_medium][ob_high] = 10;		
//		group[SocEco_rich][loc_high][ob_low] = 10;
//		group[SocEco_rich][loc_high][ob_medium] = 10;
//		group[SocEco_rich][loc_high][ob_high] = 10;
				
		//define egos
		Random rand = new Random();
		int egoIndex = 0;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				{
					for(int m = 0; m < group[i][j]; m++)
					{
						egos.get(egoIndex).initialise(rand.nextGaussian() + 1, i, j);
						egoIndex++;
					}
				}
			}			
		}
		
		for(int i = 0; i < egos.size(); i++)
		{
			egos.get(i).assignNearestNeighbours();
		}		
		
		averageHAdvEnergy = new double[iteration];
		totalHAdvEnergy = new double[iteration];
		averageAdEnergy = new double[iteration];
		totalAdEnergy = new double[iteration];
		action = new double[iteration];
		setNodeValues();
		biuldUpSocialNetwork();
	}
	
	public void addSourceMeme(SourceMeme meme)
	{
		sourceMemes.add(meme);
	}

	 private void biuldUpSocialNetwork()
	 {
		 //build up focal
		 for(int i = 0; i < focalNums; i++)
		 {
			 int index = (int)Math.floor(Math.random() * population);
			 for(int j = 0; j < 5; j++)
			 {
				 int index1 = (int)Math.floor(Math.random() * population);
				 egos.get(index).addFixedNeighbour(egos.get(index1));
			 }				 
		 }
		 
		 //add some random links

		 for(int i = 0; i < randomfocalLinks; i++)
		 {
			 int index = (int)Math.floor(Math.random() * population);
			 int index1 = (int)Math.floor(Math.random() * population);
			 egos.get(index).addFixedNeighbour(egos.get(index1));
		 }
		 
	 }

	
	public void run() throws Exception
	{
		for(int i = 0; i < sourceMemes.size(); i++)
		{
			setSeeds(sourceMemes.get(i));
		}
		for(int i = 0; i < iteration; i++)
		{
			for(int j = 0; j < population; j++)
			{
				egos.get(j).infoDefuse(i);
			}
			for(int j = 0; j < population; j++)
			{
				egos.get(j).calculateReaction();
			}	
			record(i);
			for(int j = 0; j < population; j++)
			{
				egos.get(j).wane();
			}
		}
		
//		debugPrint();
		
		outputToFile();
	}
	
	private void setNodeValues()
	{
		String[] nodeNames = bayesNet.getAllNodeIds();
		for(int i = 0; i < nodeNames.length; i++)
		{
			String nodeName = nodeNames[i];
	        String[] values = bayesNet.getOutcomeIds(nodeName);

			if(nodeName.endsWith("HAdv_React"))
			{
				for(int j = 0; j < 3; j++)
				{
					hAdv_ReactValues[j] = new String(values[j]);
				}
				
			}
			else if(nodeName.endsWith("Ad_React"))
			{
				for(int j = 0; j < 3; j++)
				{
					ad_ReactValues[j] = new String(values[j]);
				}
			}
			else if(nodeName.endsWith("React"))
			{
				for(int j = 0; j < 3; j++)
				{
					reactValues[j] = new String(values[j]);
				}
			}
			else if(nodeName.endsWith("Action"))
			{
				for(int j = 0; j < 3; j++)
				{
					actionValues[j] = new String(values[j]);
				}
				react_group = new double[iteration][27];
				for(int j = 0; j < iteration; j++)
				{
					for(int k = 0; k < 27; k++)
					{
						react_group[j][k] = 0;
					}
				}
			}
			else 
			{
				
			}
		}

	}
	private void setSeeds(SourceMeme sourceMeme)
	{
		Meme meme = new Meme(sourceMeme);
		int seedsNum = meme.getSeedsNum();
		int[] indexes = new int[seedsNum];
		int selectedNum = 0;
		while(selectedNum < seedsNum)
		{
			int index = (int)Math.floor(Math.random() * population);
			boolean selected = false; 
			for(int i = 0; !selected && i < selectedNum; i++)
			{
				if(index == indexes[i])
				{
					selected = true;
				}
			}
			if(!selected)
			{
				indexes[selectedNum] = index;
				selectedNum++;
			}
		}
		for(int i = 0; i < seedsNum; i++)
		{
			egos.get(indexes[i]).addMeme(meme);
		}
	}
	
	private void record(int it) throws Exception
	{
		totalHAdvEnergy[it] = 0.0d;
		totalAdEnergy[it] = 0.0d;
		int hAdvCount = 0;
		int adCount = 0;
		action[it] = 0;
		for(int i = 0; i < egos.size(); i++)
		{
			double hAdvEne = egos.get(i).getHAdvEnery();
			double adEne = egos.get(i).getAdEnery();
			if(hAdvEne > 0)
			{
				hAdvCount++;
				totalHAdvEnergy[it] += hAdvEne;
//System.out.println(totalHAdvEnergy[it]);
			}
			if(adEne > 0)
			{
				adCount++;
				totalAdEnergy[it] += adEne;
			}
			
			double[] thisReactProb = egos.get(i).getReactProbs();	
			//record actions
			for(int j = 0; j < thisReactProb.length; j++)
			{
				if(actionValues[j].equals("high"))
				{
					action[it] += 3 * thisReactProb[j];
				}
				else if(actionValues[j].equals("medium"))
				{
					action[it] += 2 * thisReactProb[j];
				}
				else if(actionValues[j].equals("low"))
				{
					action[it] += thisReactProb[j];
				}
				else
				{
					throw new Exception();
				}
			}			
				
			//calculate group index
			int groupIndex = egos.get(i).getLoc() * 9
					+ egos.get(i).getOb() * 3 + egos.get(i).getSocEco();			
			double[] thisActionProb = egos.get(i).getActionProbs();			
			for(int j = 0; j < thisActionProb.length; j++)
			{
				if(actionValues[j].equals("high"))
				{
					react_group[it][groupIndex] += 3 * thisActionProb[j];
				}
				else if(actionValues[j].equals("medium"))
				{
					react_group[it][groupIndex] += 2 * thisActionProb[j];
				}
				else if(actionValues[j].equals("low"))
				{
					react_group[it][groupIndex] += thisActionProb[j];
				}
				else
				{
					throw new Exception();
				}
			}			
		}
		averageHAdvEnergy[it] = totalHAdvEnergy[it] / hAdvCount;
		averageAdEnergy[it] = totalAdEnergy[it] / adCount;	
	}
	
	private void debugPrint()
	{
		System.out.println("id,meme type,defusion mode,energy," +
				"happen time,seeds,defusion rate,waining rate");
		for(int i = 0; i < sourceMemes.size(); i++)
		{
			sourceMemes.get(i).debugPrint();
		}
		System.out.println();
		
		
		System.out.print("iteration,total HAdv,average HAdv,total Ad, average Ad");

		System.out.print(",locL obL soL,locL obL soM,locL obL soH");
		System.out.print(",locL obM soL,locL obM soM,locL obM soH");
		System.out.print(",locL obH soL,locL obH soM,locL obH soH");
		System.out.print(",locM obL soL,locM obL soM,locM obL soH");
		System.out.print(",locM obM soL,locM obM soM,locM obM soH");
		System.out.print(",locM obH soL,locM obH soM,locM obH soH");
		System.out.print(",locH obL soL,locH obL soM,locH obL soH");
		System.out.print(",locH obM soL,locH obM soM,locH obM soH");
		System.out.print(",locH obH soL,locH obH soM,locH obH soH");		
		System.out.print(",reaction");		
		System.out.println();
		for(int i = 0; i < iteration; i++)
		{
			System.out.print(i + 1);
			System.out.print("," + totalHAdvEnergy[i] + 
			                 "," + averageHAdvEnergy[i] +
			                 "," + totalAdEnergy[i] +
			                 "," + averageAdEnergy[i]);

			for(int j = 0; j < 27; j++)
			{
				System.out.print("," + react_group[i][j]); 
			}
			
			System.out.print("," + action[i]);			
			
			System.out.println();
		}
	}
	

	private String getOutputFileName()
	{
		//id=1,2, memeEnery, memeHappeningTime=0, memeSeedsNum, 
		//memePropagationRate, memeWaningRate, memetype=HADV/AD, defusionType
		//HAdv
		SourceMeme hAdv = sourceMemes.get(0);
		SourceMeme ad = sourceMemes.get(1);
		String fileName = String.valueOf(result_path +
				hAdv.eneryIni)+ "-" +
				String.valueOf(hAdv.seedsNum) + "-" +
				String.valueOf(hAdv.propagationRate) + "-" +
				String.valueOf(hAdv.waningRate) + "-" + 
				String.valueOf(hAdv.getDiffusionType()) + "-" + 				
				String.valueOf(ad.eneryIni) + "-" +
				String.valueOf(ad.seedsNum) + "-" +
				String.valueOf(ad.propagationRate) + "-" +
				String.valueOf(ad.waningRate) + "-" +
				String.valueOf(ad.getDiffusionType()) + ".txt" ;
		return fileName;
	}
	
	private void outputToFile() 
	throws IOException
	{
		
		String fileName = getOutputFileName();
	    FileWriter fstream = new FileWriter(fileName);
	    BufferedWriter out = new BufferedWriter(fstream);
	    
		out.append("id,meme type,defusion mode,energy," +
				"happen time,seeds,defusion rate,waining rate\n");
		for(int i = 0; i < sourceMemes.size(); i++)
		{
			sourceMemes.get(i).outputToFile(out);
		}
		out.append("\n");
		
		
		out.append("iteration,total HAdv,average HAdv,total Ad, average Ad");

		out.append(",locL obL soL,locL obL soM,locL obL soH");
		out.append(",locL obM soL,locL obM soM,locL obM soH");
		out.append(",locL obH soL,locL obH soM,locL obH soH");
		out.append(",locM obL soL,locM obL soM,locM obL soH");
		out.append(",locM obM soL,locM obM soM,locM obM soH");
		out.append(",locM obH soL,locM obH soM,locM obH soH");
		out.append(",locH obL soL,locH obL soM,locH obL soH");
		out.append(",locH obM soL,locH obM soM,locH obM soH");
		out.append(",locH obH soL,locH obH soM,locH obH soH");		
		out.append(",react");		
		out.append(",action");		
		out.append("\n");
		
		double[] react_all = new double[iteration];
		for(int i = 0; i < iteration; i++)
		{
			out.append(String.valueOf(i + 1));
			out.append("," + totalHAdvEnergy[i] + 
			                 "," + averageHAdvEnergy[i] +
			                 "," + totalAdEnergy[i] +
			                 "," + averageAdEnergy[i]);
			react_all[i] = 0;
			for(int j = 0; j < 27; j++)
			{
				out.append("," + react_group[i][j]); 
				react_all[i] += react_group[i][j];
			}

			out.append("," + react_all[i]);	
			out.append("," + action[i]);			
			
			out.append("\n");
		}
		out.close();
		fstream.close();
	}

}
