import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;


public class Summary {

	/**
	 * @param args
	 * @throws IOException 
	 */
	
	public static void main(String[] args) throws IOException 
	{
		FileWriter fstream = new FileWriter(Sociaty.result_path + "summary.txt");
		
		BufferedWriter out = new BufferedWriter(fstream);
        out.append("hAdvEnery,hAdvSeed,hAdvDiffRate,hAdvWaningRate,hAdvTopo," +
        		"adEnery,adSeed,adDiffRate,adWaningRate,adTopo," +
        		"react trend,start time,end time," + 
				"action trend,start time,end time\n"); 
        
		String[] hAdvEnery = {"0.8-","1.0-"};
    	String[] hAdvSeed = {"2-","3-"};
    	String[] hAdvDiffRate = {"0.02-","0.03-"};
    	String[] hAdvWaningRate = {"0.8-","0.9-"};
    	String[] hAdvTopo = {"random-", "fixed-", "nearest-"};
    	String[] adEnery = {"0.5-","0.8-"};
    	String[] adSeed = {"10-","15-"};
    	String[] adDiffRate = {"0.05-","0.08-"};
    	String[] adWaningRate = {"0.9-","0.95-"};
    	String[] adTopo = {"random.txt", "fixed.txt", "nearest.txt"};
    	
    	double[] react = new double[Sociaty.iteration];
    	double[] action = new double[Sociaty.iteration];
//    	recordOneFile("D:\\workspace\\BNIntervention\\fullResults\\"+ 
//    			"0.8-2-0.02-0.9-fixed-0.5-10-0.05-0.95-nearest.txt",
//    			react, action, out);
//    	out.close();
    	for(int i1 = 0; i1 < 2; i1++)
    	{
        	for(int i2 = 0; i2 < 2; i2++)
        	{
            	for(int i3 = 0; i3 < 2; i3++)
            	{
                	for(int i4 = 0; i4 < 2; i4++)
                	{
                    	for(int i5 = 0; i5 < 3; i5++)
                    	{
                        	for(int i6 = 0; i6 < 2; i6++)
                        	{
                            	for(int i7 = 0; i7 < 2; i7++)
                            	{
                                	for(int i8 = 0; i8 < 2; i8++)
                                	{
                                    	for(int i9 = 0; i9 < 2; i9++)
                                    	{
                                        	for(int i10 = 0; i10 < 3; i10++)
                                        	{
                                        		String fileName = 
                                        			Sociaty.result_path + 
                                        			hAdvEnery[i1] + 
                                        			hAdvSeed[i2] +
                                        			hAdvDiffRate[i3] +
                                            		hAdvWaningRate[i4] +
                                        			hAdvTopo[i5] +
                                        			adEnery[i6] +
                                        			adSeed[i7] +                                        			
                                            		adDiffRate[i8] +
                                            		adWaningRate[i9] + 
                                            		adTopo[i10];
                                        		out.append(
                                        			hAdvEnery[i1] + "," +
                                        			hAdvSeed[i2] + "," +
                                        			hAdvDiffRate[i3] + "," +
                                            		hAdvWaningRate[i4] + "," +
                                        			hAdvTopo[i5] + "," +
                                        			adEnery[i6] + "," +
                                        			adSeed[i7] + "," +                                  			
                                            		adDiffRate[i8] + "," +
                                            		adWaningRate[i9] +  "," +
                                            		adTopo[i10] + ",");
                                        		recordOneFile(fileName, 
                                        				react, action, out);
                                        	}	
                                    	}	
                                	}	
                            	}	
                        	}
                    	}
                	}
            	}
        	}
    	}
    	out.close();
	}
	
	static private void recordOneFile(String fileName, 
			double[] react, double[] action, BufferedWriter out) throws IOException
	{		
		FileInputStream in = null;
		if((in = new FileInputStream(fileName)) != null)
		{
			BufferedReader br = 
				new BufferedReader(new InputStreamReader(in));
		    for(int i = 0; i < 5; i++)
		    {
		    	br.readLine();
		    }
		    String strLine = null;
		    for(int i = 0; i < Sociaty.iteration; i++)
		    {
		    	strLine = br.readLine();
		    	if(strLine == null)
		    	{
		    		throw new IOException();
		    	}
		    	String[] ss = strLine.split(",");
		    	react[i] = Double.parseDouble(ss[32]);
		    	action[i] = Double.parseDouble(ss[33]);
		    }         
		    analyseOneFile(react, out);
		    analyseOneFile(action, out);
		}				 
	    in.close();
	}
	
	static private void analyseOneFile(double[] data, BufferedWriter out) 
	throws IOException
	{
		analyseOneFile(0, Sociaty.iteration - 1, data, out); 
	}

	static private void analyseOneFile(int startTime, int endTime,
			double[] data, BufferedWriter out) 
	throws IOException
	{
		double change = 100;
		while(Math.abs(change) < 1E-8 && endTime > 0)
		{
			change = data[endTime] - data[endTime - 1];
			endTime--;
		}
		endTime++;
		
		change = 0;
		while(Math.abs(change) < 1E-8 && startTime < endTime)
		{
			change = data[startTime + 1] - data[startTime];
			startTime++;
		}
		startTime--;
		
		double averaveTrend = 0;
		for(int i = startTime; i <= endTime; i++)
		{
			averaveTrend +=  data[i];
		}
		averaveTrend /= endTime - startTime + 1;
		
		if(averaveTrend > data[Sociaty.iteration - 1])
		{
			out.append("better,");
		}
		else if(averaveTrend > data[Sociaty.iteration - 1])
		{
			out.append("worser,");
		}
		else//averaveTrend = react[Sociaty.iteration - 1]
		{
			out.append("no trend,");
		}	
	}
}
