import java.util.List;

import smile.Network;


public class TestBN {

	/**
	 * @param args
	 */	
	private static String path = "P:\\project\\workspace\\BNIntervention\\model\\";
	private static String netFile = "intervention.xdsl";	
	private static Network bayesNet;
	private static List<SourceMeme> sourceMemes;
	
	public static void main(String[] args) 
	{
		bayesNet = new Network();
		bayesNet.readFile(path + netFile); 
		String[] allNodeNames = bayesNet.getAllNodeIds();
		String[] nodeNames = {"Ob", "Loc", "Soc_Eco", "HAdv", "Ad"};
		String[][] nodeValues = new String[5][];
		for(int i = 0; i < allNodeNames.length; i++)
		{
			boolean cont = true;
			for(int j = 0; cont && j < 5; j++)
			{
				if(allNodeNames[i].equals(nodeNames[j]))
				{
					nodeValues[j] = bayesNet.getOutcomeIds(allNodeNames[i]);
					cont = false;
				}
			}
		}
		
		int[] i = new int[5];
		for(int i0 = 0; i0 < 5; i0++)
		{
			i[i0] = i0;
		}
		
		System.out.println("Ob, Loc, Soc_Eco, HAdv, Ad, react_high, react_medium,react_low, " +
				"action_high, action_medium,action_low,");
 		for(i[0] = 0; i[0] < 3; i[0]++)
		{
			for(i[1] = 0; i[1] < 3; i[1]++)
			{
				for(i[2] = 0; i[2] < 3; i[2]++)
				{
					for(i[3] = 0; i[3] < 3; i[3]++)
					{
						for(i[4] = 0; i[4] < 3; i[4]++)
						{
							bayesNet.clearAllEvidence();
							for(int j = 0; j < 5; j++)
							{
								System.out.print(nodeValues[j][i[j]] + ",");
								bayesNet.setEvidence(nodeNames[j], nodeValues[j][i[j]]);
							}
							bayesNet.updateBeliefs();
							
							//debugPrint;
							double[] reactProbs = null;
							double[] actionProbs = null;
							for(int j = 0; j < allNodeNames.length; j++)
							{
								if(allNodeNames[j].equals("React"))
								{
									reactProbs = bayesNet.getNodeValue(allNodeNames[j]);
								}
								else if(allNodeNames[j].equals("Action"))
								{
									actionProbs = bayesNet.getNodeValue(allNodeNames[j]);
								}
							}
							for(int j = 0; j < reactProbs.length; j++)
							{
								System.out.print(reactProbs[j] + ",");
							}	
							for(int k = 0; k < actionProbs.length; k++)
							{
								System.out.print(actionProbs[k] + ",");
							}					
					 		System.out.println();
						}
					}
				}
			}
		}
	}
	

}
